const Gio = imports.gi.Gio;
const St = imports.gi.St;
const Main = imports.ui.main;
const Layout = imports.ui.layout;
const Overview = imports.ui.overview;
const overviewControls = imports.ui.overviewControls;
const Lang = imports.lang;
const Shell = imports.gi.Shell;
const panel = imports.ui.panel;
const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();
const activitiesButton = imports.ui.panel.ActivitiesButton.prototype;

//icons in [extension folder]/img you can replace with same name
//I will write option later.


const expose_iconPath = Me.path + '/img/windowslist.svg';
const launchpad_iconPath = Me.path + '/img/logo.svg';
let launchpad_button, expose_button, rb_index;


//I try to write code with New Lang({}) style but wont work.
//I will find solution later.
//I need more infomation.
//I must reserach more.


function init() {
    init_launchpad();
    init_expose();
}

function enable() {
    enable_launchpad();
    enable_expose();
}

function disable() {
    disable_launchpad();
    disable_expose();

}
function init_expose() {

    expose_button = new St.Bin({ style_class: 'panel-button',
                          reactive: true,
                          can_focus: true,
                          x_fill: true,
                          y_fill: true,
                          track_hover: true }); 
    let expose_icon = new St.Icon({ 
                          gicon: Gio.icon_new_for_string(expose_iconPath),
                          style_class: 'system-status-icon'});
    expose_button.set_child(expose_icon);
    expose_button.connect('button-press-event', function(){ 
      if (!Main.overview.visible) {
        Main.overview.toggle();
      } else { 
        if (Main.overview.viewSelector._showAppsButton.checked) {
            Main.overview.viewSelector._showAppsButton.checked = false;
        } else {
              Main.overview.toggle();
        } 
      }
    }); 
}
function enable_expose() {
    rb_index = Main.panel._rightBox.get_children();
    Main.panel._rightBox.insert_child_at_index(expose_button, rb_index.length +1);
}
function disable_expose() {
    Main.panel._rightBox.remove_child(expose_button);
}
function init_launchpad() {
        tmp_onKeyRelease = activitiesButton._onKeyRelease;
        tmp_xdndToggleOverview = activitiesButton._xdndToggleOverview;
}
function enable_launchpad() {
        activitiesButton._onKeyRelease = function(actor, event) { 
          let symbol = event.get_key_symbol();
          if (symbol == Clutter.KEY_Return || symbol == Clutter.KEY_space) {
              if (!Main.overview.visible) {
                    Main.overview.toggle();Main.overview.viewSelector._showAppsButton.checked = true;
              } else { 
                    if (Main.overview.viewSelector._showAppsButton.checked) {
                        Main.overview.viewSelector._showAppsButton.checked = false;
                        Main.overview.toggle();
                    } else {
                        Main.overview.viewSelector._showAppsButton.checked = true;
                    } 
              }
          }
        return Clutter.EVENT_PROPAGATE; }
        activitiesButton._xdndToggleOverview = function(actor) {
        let [x, y, mask] = global.get_pointer();
        let pickedActor = global.stage.get_actor_at_pos(Clutter.PickMode.REACTIVE, x, y);
        if (pickedActor == this.actor && Main.overview.shouldToggleByCornerOrButton())
              if (!Main.overview.visible) {
                    Main.overview.toggle();Main.overview.viewSelector._showAppsButton.checked = true;
              } else { 
                    if (Main.overview.viewSelector._showAppsButton.checked) {
                        Main.overview.viewSelector._showAppsButton.checked = false;
                        Main.overview.toggle();
                    } else {
                        Main.overview.viewSelector._showAppsButton.checked = true;
                    } 
              }
        Mainloop.source_remove(this._xdndTimeOut);
        this._xdndTimeOut = 0;
        return GLib.SOURCE_REMOVE;
      }
}
function disable_launchpad() {
       activitiesButton._onKeyRelease = tmp_onKeyRelease;
       activitiesButton._xdndToggleOverview = tmp_xdndToggleOverview;
}

